import { EffectModule, ActionOfEffectModule, StateInEffectModule } from '@stringke/sigi-core';
import { ConstructorOf } from '@stringke/sigi-types';
import type { ComponentOptions } from 'vue';
import type { RecordPropsDefinition, DataDef } from 'vue/types/options';
import type { CombinedVueInstance } from 'vue/types/vue';
declare type ReactiveComponentOptions<M extends EffectModule<any>, V extends Vue, Data, Methods, Computed, Prop> = {
    syncToSigi?: Array<keyof StateInEffectModule<M>>;
} & (Prop extends string ? ComponentOptions<V, DataDef<Data, Record<Prop, any>, V>, Methods, Computed, Prop[], Record<Prop, any>> & ThisType<CombinedVueInstance<V, StateInEffectModule<M> & Data, ActionOfEffectModule<M, StateInEffectModule<M>> & Methods, Computed, Readonly<Record<Prop, any>>>> : ComponentOptions<V, DataDef<Data, Prop, V>, Methods, Computed, RecordPropsDefinition<Prop>, Prop> & ThisType<CombinedVueInstance<V, StateInEffectModule<M> & Data, ActionOfEffectModule<M, StateInEffectModule<M>> & Methods, Computed, Readonly<Prop>>>);
export declare const reactive: <M extends EffectModule<any>, V extends import("vue/types/umd"), Data, Methods, Computed, PropDef = object, Props = object>(EffectModuleConstructor: ConstructorOf<M>, componentOptions: ReactiveComponentOptions<M, V, Data, Methods, Computed, PropDef>) => ComponentOptions<V, StateInEffectModule<M> & (Data extends never ? object : Data extends (...args: any) => any ? ReturnType<Data> : Data), Omit<{ [key in keyof M]: ((M[key] extends (action$: import("rxjs").Observable<infer Payload>) => import("rxjs").Observable<import("@stringke/sigi-types").Action<unknown>> ? Payload : never) extends never ? (M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>) => void ? void : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>, payload: infer Payload_1) => void ? Payload_1 : never) extends never ? (M[key] extends (state: StateInEffectModule<M>) => StateInEffectModule<M> ? void : M[key] extends (State: StateInEffectModule<M>, payload: infer Payload_2) => StateInEffectModule<M> ? Payload_2 : never) extends never ? (M[key] extends import("rxjs").Observable<infer P> ? P : never) extends never ? never : M[key] extends import("rxjs").Observable<infer P> ? P : never : M[key] extends (state: StateInEffectModule<M>) => StateInEffectModule<M> ? void : M[key] extends (State: StateInEffectModule<M>, payload: infer Payload_2) => StateInEffectModule<M> ? Payload_2 : never : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>) => void ? void : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>, payload: infer Payload_1) => void ? Payload_1 : never : M[key] extends (action$: import("rxjs").Observable<infer Payload>) => import("rxjs").Observable<import("@stringke/sigi-types").Action<unknown>> ? Payload : never) extends void ? () => void : (payload: (M[key] extends (action$: import("rxjs").Observable<infer Payload>) => import("rxjs").Observable<import("@stringke/sigi-types").Action<unknown>> ? Payload : never) extends never ? (M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>) => void ? void : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>, payload: infer Payload_1) => void ? Payload_1 : never) extends never ? (M[key] extends (state: StateInEffectModule<M>) => StateInEffectModule<M> ? void : M[key] extends (State: StateInEffectModule<M>, payload: infer Payload_2) => StateInEffectModule<M> ? Payload_2 : never) extends never ? (M[key] extends import("rxjs").Observable<infer P> ? P : never) extends never ? never : M[key] extends import("rxjs").Observable<infer P> ? P : never : M[key] extends (state: StateInEffectModule<M>) => StateInEffectModule<M> ? void : M[key] extends (State: StateInEffectModule<M>, payload: infer Payload_2) => StateInEffectModule<M> ? Payload_2 : never : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>) => void ? void : M[key] extends (state: import("immer").Draft<StateInEffectModule<M>>, payload: infer Payload_1) => void ? Payload_1 : never : M[key] extends (action$: import("rxjs").Observable<infer Payload>) => import("rxjs").Observable<import("@stringke/sigi-types").Action<unknown>> ? Payload : never) => void; }, keyof EffectModule<S>> & {
    terminate: () => void;
    reset: () => void;
    noop: () => void;
} & (Methods extends never ? object : Methods), Computed, PropDef, Props>;
export {};
